module Top_module(
                  input wire clk,
                  input wire x1,
                  input wire UART_RX,
                  output wire x2,
                  output wire UART_TX
                  );

wire reset; 
wire [15:0] thigh;
wire [15:0] tlow;  
wire start_division; 
wire [31:0] division_result;
wire [31:0] accumulator;
wire division_completed; 
wire [7:0] UART_RX_data; 
wire UART_RX_valid;
wire UART_TX_completed;
wire [7:0] UART_TX_data;  
wire UART_TX_valid;
wire UART_TX_active;

reset_generator   m0    (
                        clk,
                        reset
                        ); 

count_periods     m1    (
                         reset,
                         clk,
                         x1,
                         x2,
                         thigh,
                         tlow,
                         start_division
                         );

division          m2     (
                          reset,
                          clk,
                          thigh,
                          tlow,
                          start_division,
                          division_result,
                          accumulator,
                          division_completed
	                     );                        

UART_control      m3     (
                          reset,
                          clk, 
                          UART_RX_data,
                          UART_RX_valid,
                          UART_TX_completed, 
                          division_result,
                          division_completed, 
                          UART_TX_data,
                          UART_TX_valid
                         );  

uart_rx          m4      (
                          clk,
                          UART_RX,
                          UART_RX_valid,
                          UART_RX_data
                         );

uart_tx          m5      (
                          clk,
                          UART_TX_valid,
                          UART_TX_data, 
                          UART_TX_active,
                          UART_TX,
                          UART_TX_completed
                         );

endmodule